if not (IsAddOnLoaded("ElvUI") or IsAddOnLoaded("Tukui")) then return end

local U = select(2, ...)
local s, c

if ElvUI then
    local E, L, V, P, G, DF = unpack(ElvUI)
    local S = E:GetModule("Skins")
    U.s = S
    U.c = E
    U.ccolor = E.myclass
    s = S
    c = E
else
    local T, C, L, G = unpack(Tukui)
    U.s = T
    U.c = C
    U.ccolor = T.myclass
    s = T
    c = C
    c.TexCoords = {.08, .92, .08, .92}
end

function U.SkinButton(self, strip)
    if ElvUI then
        s:HandleButton(self, strip)
    else
        s.SkinButton(self, strip)
    end
end

function U.SkinScrollBar(self)
    if ElvUI then
        s:HandleScrollBar(self)
    else
        s.SkinScrollBar(self)
    end
end

function U.SkinTab(self)
    if ElvUI then
        s:HandleTab(self)
    else
        s.SkinTab(self)
    end
end

function U.SkinNextPrevButton(self, horizonal)
    if ElvUI then
        s:HandleNextPrevButton(self, horizonal)
    else
        s.SkinNextPrevButton(self, horizonal)
    end
end

function U.SkinEditBox(self)
    if ElvUI then
        s:HandleEditBox(self)
    else
        s.SkinEditBox(self)
    end
end

function U.SkinDropDownBox(self, width)
    if ElvUI then
        s:HandleDropDownBox(self, width)
    else
        s.SkinDropDownBox(self, width)
    end
end

function U.SkinCheckBox(self)
    if ElvUI then
        s:HandleCheckBox(self)
    else
        s.SkinCheckBox(self)
    end
end

function U.SkinCloseButton(self)
    if ElvUI then
        s:HandleCloseButton(self)
    else
        s.SkinCloseButton(self)
    end
end

function U.SkinSliderFrame(self, height)
    if ElvUI then
        s:HandleSliderFrame(self)
    else
        s.SkinSlideBar(self, height, movetext)
    end
end

function U.SkinFrame(self)
    self:StripTextures(True)
    self:SetTemplate("Transparent")
end

function U.SkinFrameD(self)
    self:StripTextures(True)
    self:SetTemplate("Default")
end

function U.SkinStatusBar(self)
    self:StripTextures(true)
    self:CreateBackdrop()
    self:SetStatusBarTexture(c.media.normTex)
end

function U.ColorItemBorder(object, quality)
    if quality and quality > 1 then 
        object:SetBackdropBorderColor(GetItemQualityColor(quality))
    else
        object:SetBackdropBorderColor(unpack(c.media.bordercolor))
    end
end

function U.SkinInventoryLine(object)
    object:SetHighlightFontObject(object:GetNormalFontObject())
    object:GetNormalTexture():SetTexCoord(unpack(c.TexCoords))
    object:GetNormalTexture():SetSize(14, 14)
    object:GetDisabledTexture():Height(6)
end

function U.SkinSearchBox(editBox, width)
    local frame = editBox:GetParent()
    U.SkinEditBox(editBox)
    editBox:Size(width or editBox:GetWidth(), editBox:GetHeight() - 5)
    editBox:SetAutoFocus(true)
    editBox:Hide()
    frame.editBox = editBox
    
    frame.searchLabel = frame:CreateFontString(nil, "ARTWORK")
    frame.searchLabel:SetFontObject(editBox:GetFontObject())
    frame.searchLabel:SetAllPoints(editBox)
    frame.searchLabel:SetJustifyH("LEFT")
    frame.searchLabel:SetText("|cff9999ff" .. SEARCH)
    
    frame.OpenSearchBox = function(self)
        self.searchLabel:Hide()
        self.editBox:Show()
        self.editBox:SetFocus()
    end
    frame.CloseSearchBox = function(self)
        self.editBox:Hide()
        self.searchLabel:Show()
    end

    local button = CreateFrame("Button", nil, frame)
    button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
    button:SetAllPoints(frame.searchLabel)
    button:SetScript("OnClick", function(self, button)
        local frame = self:GetParent()
        if button == "RightButton" then
            frame:OpenSearchBox()
        elseif frame.editBox:IsShown() then
            frame:CloseSearchBox()
        else
            frame:OpenSearchBox(self)
        end
    end)
    
    editBox:HookScript("OnEditFocusLost", function(self)
        self:GetParent():CloseSearchBox()
    end)
end

function U.SkinArmoryFrame(frame, isSideFrame)
    local closeButton = _G[frame:GetName().."CloseButton"] or _G[frame:GetName():gsub("Frame", "CloseButton")]
    local title = _G[frame:GetName().."TitleText"] or _G[frame:GetName():gsub("Frame", "TitleText")]
    U.SkinCloseButton(closeButton)
    U.SkinFrame(frame)
    frame:SetSize(338, 424)
    closeButton:Point("TOPRIGHT", frame, "TOPRIGHT", 3, 3)
    title:ClearAllPoints()
    title:Point("TOP", frame, "TOP", 0, -3)
    if isSideFrame then
        frame:Point("TOPLEFT", ArmoryFrame, "TOPRIGHT", 45, 0)
    end
end
